'FFSubmenu=Rahmen
'FFName=MFDL-Muster

'(c) Harald Maeckler, Dsseldorf 2008

' ********************************************************************
' MFDL_Muster.vbs (Script fr FixFoto)
' Funktion:	Musterbilder mit MFDL-Rahmen erzeugen
'
' Version 3.02 vom 10.07.2009	- Lschroutine hinzugefgt und KB entsprechend ergnzt
' Version 3.01a v. 04.01.2009	- Kurzbeschreibung angepasst
' Version 3.01 vom 30.11.2008	- Turboversion
'								  Bild wird vor der Mustererzeugung verkleinert und dann Absolutwerte
'								  multipliziert mit Verhltnis der lngsten Seiten vom Original zur Verkleinerung
' Version 3.00 vom 17.11.2008	- Darstellungsfehler in der Rahmenart 'Verlauf' beseitigt
' Version 2.02 vom 17.11.2008	- kleine nderungen in den Unterversionen a und b
' Version 2.01 vom 14.11.2008	- Verkleinerung whlbar mit Angaben zur maximalen Breite und Hhe
' Version 2.00 vom 12.11.2008	- Mustererzeugung abbrechbar mit Backspace-Taste
'								- Standrdardordner passend zum MFDL-Manager
'								- JPEG-Qualitt eintstellbar
' Version 1.05 vom 09.11.2008	- Beta 5 - Bugs beseitigt
' Version 1.04 vom 08.11.2008	- Beta 4 - mit Text einblenden
' Version 1.03 vom 07.11.2008	- Beta 3 - mit 3D-Verlauf, Schrgschnitt
' Version 1.02 vom 06.11.2008	- Beta 2 - mit Verlauf
' Version 1.01 vom 05.11.2008	- Beta 1 - ohne Verlauf, 3D-Verlauf, Schrgschnitt, Text einblenden
' Version 1.00 vom 25.10.2008	- erste Versuche
'  
'** Start Kurzbeschreibung *******************************************
' MFDL-Muster erzeugen / Version 3.02
' =======================
' Das im Arbeitsfenster geladene Bild wird als Vorlage nacheinander mit den in der
' Rahmendatei abgespeicherten MFDL-Rahmen versehen und unter dem Rahmen-
' namen ohne Exif-Daten mit einstellbarer JPEG-Qualitt im Ordner fr Rahmenmuster
' abgespeichert.
' 
' Die Vorlage sollte in etwa die Gre haben, wie die Bilder, die man spter mit 
' Rahmen versehen mchte.

' Ist der Rahmennamen als Dateiname nicht zulssig, d.h. er enthlt eins der
' Zeichen /, \, :, *, ?, ", <, > oder | dann wird angeboten, den Namen zu ndern.
' Eine nderung bezieht sich allerdings nur auf den Bildernamen. Eine nderung des
' Rahmennamen muss hndisch vorgenommen werden.
'
' Die Mustererzeugung kann jederzeit durch Bettigung der Backspacetaste abgebrochen
' werden. Die Taste muss festgehalten werden bis die Abbruchmeldung angezeigt wird.
'
' Rahmendatei
' ----------------
' Das ist die Datei mit den Rahmentexten. Mit 'Standard' kann immer die FF-Standarddatei
' 'MFDL.cfg' im Skriptordner des FF-Programmordners angesteuert werden. Aber auch die
' Auswahl einer anderen Rahmendatei ist ber '...' mglich.
' 
' Ordner fr Rahmenmuster
' -------------------------------
' In diesem Ordner werden die Rahmenmuster abgelegt. ber '...' kann ein beliebiger
' Ordner dafr festgelegt werden. Mit 'Standard' wird der Ordner 'MFDL-Muster\MFDL'
' im FF-Skriptordner eingetragen, wie er fr die Excel-Lsung 'MFDL-Manager' bentigt
' wird. Existiert er noch nicht, kann er auf Wunsch automatisch angelegt werden.
'
' JPEG-Qualitt
' ----------------
' Es kann zwischen 0, 65, 70, 75, 80, 85, 90, 95 und 100 % gewhlt werden. Bei 0
' wird die in FixFoto eingestellte Qualitt verwendet. Fr die Musterrahmen reicht
' allgemein eine Qualitt von 75 %.
'
' Verkleinern
' --------------
' Die Muster knnen nach ihrer Erstellung verkleinert werden. Die maximale Kantenlnge
' muss dafr vorgegeben werden. Empfohlen wird 500 Pixel.
'
' Deinstallation
' ========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine 
' Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft, ob das 
' zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen ange-
' boten davon eine Sicherheitskopie an einem beliebigen Speicherort abzulegen. Danach 
' werden nacheinander die Skriptdatei, die in der Registry dazugehrenden Daten und even-
' tuelle Zusatzdateien gelscht. Abschlieend wird die FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript mit 
' allen Komponenten aus der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'** Ende Kurzbeschreibung ********************************************

Option Explicit

const Turbo = true 															'false schaltet Turbo aus und true ein

const Test = "Bild um Farbe erweitern,1,0,0,5,5,0,0,0,0,0,051 051 051,000 000 000,255,0,128"
Dim Testlauf, Anzeige
Testlauf = false : Anzeige = false

Dim SkriptKill,TempFile
Dim RahmenDatei,MusterDatei,quality,boolVerkleinern,MaxLaenge
Dim Breite,Hoehe,Antwort
Dim RahmenArt,WertArray
Dim STlinks,SToben,STrechts,STunten,POlinks,POoben,POrechts,POunten
Dim Farbe
Dim RRahmFarbe,GRahmFarbe,BRahmFarbe,RVerlFarbe,GVerlFarbe,BVerlFarbe
Dim RegDeck,RegWeich,RegEffekt
Dim tmpDatei,Zeilenzahl,RDateiOK,Element,msg
Dim TextFont,Referenz,RahmenzahlGesamt,Rahmenzahl
Dim Faktor,LangeSeite

const SkriptName = "MFDL_Muster.vbs"						'Skriptname
Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch		'Kurzbeschreibung

const ForReading = 1, ForWriting = 2, ForAppending = 8

const VerbZ = "/,\,:,*,?,"""",<,>,|"						'in Dateinamen verbotene Zeichen

Dim objFS,WshShell
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

call Main
'------------------------------------------------------------------------
Sub Main	'### Hauptprogramm
Dim OK

Breite=FF_GetImageWidth()	'Breite
Hoehe =FF_GetImageHeight()	'Hoehe

if Breite = 0 then
	msgbox "Kein Bild geladen",vbCritical,"Abbruch"
	exit sub
end if

'** Start Dialog MFDL-Muster **
FF_AddDialog "MFDL-Muster",198,131
FF_AddControl "MFDL-Muster","Rahmendatei","STATIC",8,5,42,12
FF_AddControl "MFDL-Muster","Rahmentext","SLEDIT",8,18,164,10
FF_SetControlStyle "MFDL-Muster","Rahmentext",2048
FF_AddControl "MFDL-Muster","Standard","BUTTON",160,6,30,10
FF_AddControl "MFDL-Muster","...","BUTTON",180,18,10,10
FF_AddControl "MFDL-Muster","Ordner fr Rahmenmuster","STATIC",8,31,64,12
FF_AddControl "MFDL-Muster","Muster","SLEDIT",8,44,164,10
FF_SetControlStyle "MFDL-Muster","Muster",2048
FF_AddControl "MFDL-Muster","|Standard","BUTTON",160,32,30,10
FF_AddControl "MFDL-Muster","|...","BUTTON",180,44,10,10
FF_AddControl "MFDL-Muster","JPEG-Qualitt (0 = FF-Einstellung)","STATIC",23,69,85,11
FF_AddControl "MFDL-Muster","JPEGquality","COMBO",108,69,33,10
FF_AddControl "MFDL-Muster","% ","STATIC",146,69,9,11
FF_AddControl "MFDL-Muster","boolVerkleinern","BOOL",10,86,8,8
FF_AddControl "MFDL-Muster","Verkleinern auf max. Kantenlnge","STATIC",23,84,83,11
FF_AddControl "MFDL-Muster","MaxLaenge","SLEDIT",108,84,33,10
FF_SetControlStyle "MFDL-Muster","MaxLaenge",8192
FF_AddControl "MFDL-Muster","Pixel","STATIC",146,84,14,11
FF_AddControl "MFDL-Muster","?","BUTTON",8,110,12,12
FF_AddControl "MFDL-Muster","Abbrechen","BUTTON",81,110,51,12
FF_AddControl "MFDL-Muster","Muster erzeugen","BUTTON",139,110,51,12
FF_AddControl "MFDL-Muster","&d","BUTTON",52,113,1,1
'** End Dialog MFDL-Muster **

call RegistryLesen
FF_ActivateControl "MFDL-Muster","&d"

do	
	Select Case FF_ShowDialog ("MFDL-Muster")
	Case "&d"
		Abbruch = false
		SkriptKill = false
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "mit allen dazugehrigen Komponenten wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "..."	'Rahmendatei ermitteln
		tmpDatei = FF_EnterFileName(true,RahmenDatei)
		if len(tmpDatei) > 2 then
			RahmenDatei = tmpDatei
			FF_SetControl "MFDL-Muster","Rahmentext",RahmenDatei
		end if
	Case "Standard"
		RahmenDatei = FF_GetScriptPath() & "\MFDL.cfg"
		FF_SetControl "MFDL-Muster","Rahmentext",RahmenDatei
	Case "|..." 'Musterordner ermitteln
		tmpDatei = FF_EnterPath(true, "Auswahl des Ordners fr die Muster")
		if len(tmpDatei) > 2 then
			Musterdatei = tmpDatei
			if not right(Musterdatei,1) = "\" then Musterdatei = Musterdatei & "\"
			FF_SetControl "MFDL-Muster","Muster",Musterdatei
		end if
	Case "|Standard"
		Musterdatei = FF_GetScriptPath() & "\MFDL-Muster\MFDL\"
		FF_SetControl "MFDL-Muster","Muster",Musterdatei
	Case "?"
		Abbruch = false
		if not KBvorhanden then	call KurzbeschreibungLesen
		if KBvorhanden then
			call KurzbeschreibungAnzeigen
		else
			msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
		end if
	Case "Muster erzeugen"
		call RegistrySchreiben
		if not(objFS.FileExists(RahmenDatei)) then
			msgbox "Die Rahmendatei ist nicht vorhanden!",vbCritical,"Warnung"
		elseif not(objFS.FolderExists(Musterdatei)) then
			Antwort = msgbox("Der Musterordner ist nicht vorhanden!" & vbNewLine & _
							 "Soll er angelegt werden?",vbYesNo + vbQuestion,"Abfrage")
			if Antwort = vbYes then
				call OrdnerAnlage(Musterdatei)
				if objFS.FolderExists(Musterdatei) then
					msgbox "Die Anlage des Ordners '" & Musterdatei & "' war erfolgreich." & vbNewLine & _
						   "Bitte die Mustererzeugung neu starten!",vbInformation,"Hinweis"
				else
					msgbox "Der Musterordner konnte nicht angelegt werden!",vbCritical,"Warnung"
				end if							
			end if
		else
			call Zeilenanzahl	'Zeilen in Rahmendatei zhlen
			if not RDateiOK then
				msgbox "Die ausgewhlte Rahmendatei enthlt keine Rahmen!",vbCritical,"Warnung"
			elseif boolVerkleinern = "1" and MaxLaenge = 0 then
				msgbox "Ist Verkleinern aktiviert muss eine" & vbNewLine & _
					   "max. Kantenlnge > 0 vorgegeben werden!",vbCritical,"Warnung"
			else
				FF_CloseDialog ("MFDL-Muster")
				msg =  "Die Dauer der Mustererzeugung hngt ab von" & vbNewLine & _
					   "    - der Rechnerleistung" & vbNewLine & _
					   "    - der Vorlagengre" & vbNewLine & _
					   "    - der Rahmenanzahl" & vbNewLine & vbNewLine & _
					   "Die Vorlagengre ist Breite x Hoehe = " & Breite & " x " & Hoehe & " Pixel." & vbNewLine & _
					   "Es sollen " & RahmenzahlGesamt & " Musterrahmen erzeugt werden." & vbNewLine
				if boolVerkleinern = "1" then
					   msg = msg & "Hat das Muster eine grere Kantelnge als " & MaxLaenge & " Pixel" & vbNewline & _
								   "wird es entsprechend verkleinert." & vbNewLine
				end if		   
				msgbox msg & vbNewLine & _
					   "Die Mustererzeugung kann jederzeit mit der Backspace-Taste abgebrochen werden!" & vbNewLine & _
					   "Die Backspace-Taste festhalten bis die Abbruchmedlung angezeigt wird.",vbInformation,"Hinweis"
							
				if Turbo and boolVerkleinern = "1" then									'####### Turbo ist ein ####
					if Breite >= Hoehe then
						LangeSeite = Breite
					else
						LangeSeite = Hoehe
					end if
					
					call FF_HQScale(MaxLaenge,MaxLaenge, true)
					
					Breite=FF_GetImageWidth()
					Hoehe =FF_GetImageHeight()

					Referenz = MaxLaenge/1000
					Faktor = MaxLaenge/LangeSeite
				
				else																	'####### Turbo ist aus ####
					Faktor = 1
					if Breite >= Hoehe then
						Referenz = Breite/1000
					else
						Referenz = Hoehe/1000
					end if						
				end if
				
				FF_PushImage()
				call RahmenAuslesen
				if not Abbruch and Rahmenzahl > 0 then
					msgbox "Es wurden " & Rahmenzahl & " Muster erzeugt.",vbInformation,"Info"
				end if
				exit sub
			end if
		end if
	Case "CANCEL", "Abbrechen"
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("MFDL-Muster")
if SkriptKill then call KillSkript	'ggf. Skript komplett entfernen

End Sub
'------------------------------------------------------------------------
Sub WertErmittlung

WertArray = split(RahmenArt,",")

if WertArray(1) = "0" then				'Strke
	'Strke = Pixel
	STlinks = WertArray(2) * Faktor
	SToben  = WertArray(3) * Faktor
	STrechts= WertArray(4) * Faktor
	STunten = WertArray(5) * Faktor
else
	'Strke = Promille
	STlinks = Referenz * WertArray(2)
	if WertArray(2) > 0 and STlinks < 1 then STlinks = 1
	SToben  = Referenz * WertArray(3)
	if WertArray(3) > 0 and SToben < 1 then SToben = 1 	
	STrechts= Referenz * WertArray(4)
	if WertArray(4) > 0 and STrechts < 1 then STrechts = 1	
	STunten = Referenz * WertArray(5)
	if WertArray(5) > 0 and STunten < 1 then STunten = 1
end if

if WertArray(6) = "0" then				'Position
	'Position = Pixel
	POlinks = WertArray(7) * Faktor
	POoben  = WertArray(8) * Faktor
	POrechts= WertArray(9) * Faktor
	POunten = WertArray(10) * Faktor
else
	'Position = Promille
	POlinks = Referenz * WertArray(7)
	if WertArray(7) > 0 and POlinks < 1 then POlinks = 1
	POoben  = Referenz * WertArray(8)
	if WertArray(8) > 0 and POoben < 1 then POoben = 1	
	POrechts= Referenz * WertArray(9)
	if WertArray(9) > 0 and POrechts < 1 then POrechts = 1	
	POunten = Referenz * WertArray(10)
	if WertArray(10) > 0 and POunten < 1 then POunten = 1
end if

Farbe = split(WertArray(11)," ")		'Rahmenfarbe
RRahmFarbe = Farbe(0) * 1
GRahmFarbe = Farbe(1) * 1
BRahmFarbe = Farbe(2) * 1

Farbe = split(WertArray(12)," ")		'Verlaufsfarbe
RVerlFarbe = Farbe(0) * 1
GVerlFarbe = Farbe(1) * 1
BVerlFarbe = Farbe(2) * 1

RegDeck  = WertArray(13) * 1			'Regler Deckung (transp)
RegWeich = WertArray(14) * 1			'Regler Weich (smooth)
RegEffekt= WertArray(15) * 1			'Regler Effekt

if WertArray(0) = "Text einblenden" then TextFont = WertArray(16)

End Sub
'------------------------------------------------------------------------
Function LIMIT(c)

if c < 0 then c = 0
if c > 255 then c = 255

End Function
'------------------------------------------------------------------------
Sub CreateMask							'Maske der Rahmeneinstellung erzeugen
Dim BreiteAktuell, HoeheAktuell

BreiteAktuell=FF_GetImageWidth()	'Breite
HoeheAktuell =FF_GetImageHeight()	'Hoehe

call FF_SetArea(0,0,0,0,false,0,RegWeich * 64 / 255)

call FF_AreaFillRect(POlinks,POoben,POlinks + STlinks,HoeheAktuell - POunten,RegDeck)	'links
call FF_AreaFillRect(POlinks,POoben,BreiteAktuell - POrechts,Pooben + SToben,RegDeck)	'oben
call FF_AreaFillRect(POlinks,HoeheAktuell - POunten - STunten,BreiteAktuell - _
					 POrechts,HoeheAktuell - POunten,RegDeck)							'rechts
call FF_AreaFillRect(BreiteAktuell - POrechts - STrechts,POoben,BreiteAktuell - _
					 POrechts,HoeheAktuell - POunten - STunten,RegDeck)					'unten

End Sub
'------------------------------------------------------------------------
Sub Aufruf_Rahmenart

select case WertArray(0)				'Rahmenart
	case "Bild um Farbe erweitern"
		call ExtendCanvas
	case "Rahmenfarbe einzeichnen"
		call DrawBorder
	case "Unschrfe"
		call Blur
	case "Farbsttigung"
		call Saturation
	case "Helligkeit"
		call Brightness
	case "Kontrast"
		call Contrast
	case "Verlauf"
		call Smooth
	case "3D-Verlauf"
		call Smooth3D
	case "Schrgschnitt"
		call BevelCut
	case "Text einblenden"
		call DrawText
case else
end select

End Sub
'------------------------------------------------------------------------
Function ExtendCanvas 			'Bild um Farbe erweitern
Dim RegWeichTmp

call FF_SetArea(0,0,0,0,false,0,255)
call FF_ExtendCanvas(STlinks,STrechts,SToben,STunten,RRahmFarbe,GRahmFarbe,BRahmFarbe)

if RegDeck <> 0 and RegWeich <> 0 then
	call FF_SetArea(STlinks,SToben,Breite,Hoehe,true,RegDeck,RegWeich * 64 / 255)
	if RegWeich > 32 then RegWeichTmp = 32 else RegWeichTmp = RegWeich
	call FF_Blur(RegWeichTmp)
	call FF_SetArea(0,0,0,0,false,0,0)
end if

End Function
'------------------------------------------------------------------------
Function DrawBorder				'Rahmenfarbe einzeichnen

call CreateMask
call FF_WhiteBalance(-255,-255,-255)
call FF_WhiteBalance(RRahmFarbe,GRahmFarbe,BRahmFarbe)
	
End Function
'------------------------------------------------------------------------
Function Blur					'Unschrfe

call CreateMask
call FF_Blur(RegEffekt * 31 / 255 + 1)

End Function
'------------------------------------------------------------------------
Function Saturation				'Farbsttigung

call CreateMask
call FF_Saturation(RegEffekt / 128)

End Function
'------------------------------------------------------------------------
Function Brightness				'Helligkeit
Dim diff

diff = RegEffekt - 128
call CreateMask
call FF_WhiteBalance(diff,diff,diff)
	
End Function
'------------------------------------------------------------------------
Function Contrast				'Kontrast
Dim diff

diff = RegEffekt / 128
call CreateMask
call FF_AdjustRGB(diff,diff,diff)

if RegEffekt < 128 then
	diff = -(RegEffekt - 128)
	call FF_WhiteBalance(diff,diff,diff)
end if

End Function
'------------------------------------------------------------------------
Function Smooth					'Verlauf
Dim rdiff,gdiff,bdiff
Dim lp,tp,rp,bp
Dim n,max,r,g,b,co
Dim left,right,top,bottom

left = 0 : right = 0 : top = 0 : bottom = 0

rdiff = RVerlFarbe - RRahmFarbe
gdiff = GVerlFarbe - GRahmFarbe
bdiff = BVerlFarbe - BRahmFarbe

lp = POlinks + STlinks -1
tp = POoben + SToben-1
rp = FF_GetImageWidth - POrechts - STrechts
bp = FF_GetImageHeight - POunten - STunten

if STlinks > STrechts then max = STlinks else max = STrechts
if SToben > max then max = SToben
if STunten > max then max = STunten

for n = 0 to max - 1
	r = round(RRahmFarbe + rdiff * n / max)
	LIMIT r
	g = round(GRahmFarbe + gdiff * n / max)
	LIMIT g	
	b = round(BRahmFarbe + bdiff * n / max)
	LIMIT b
	
	co = b * (2^16) + g * (2^8) + r

	left = left + STlinks / max
	right = right + STrechts / max
	top = top + SToben / max
	bottom = bottom + STunten / max

	if left >=1 then
		call FF_VLine(tp,bp,lp,co)
		lp = lp - 1 : left = left -1
	end if

	if right >= 1 then
		call FF_VLine(tp,bp,rp,co)
		rp = rp +1 : right = right -1
	end if
	if top >= 1 then
		call FF_HLine(lp+1,rp,tp,co)
		tp = tp -1 : top = top -1
	end if
	if bottom >= 1 then
		call FF_HLine(lp+1,rp,bp,co)
		bp = bp +1 : bottom = bottom - 1
	end if
next

End Function
'------------------------------------------------------------------------
Function Smooth3D				'3D-Verlauf
Dim rdiff,gdiff,bdiff,rdd,gdd,bdd
Dim lp,tp,rp,bp
Dim n,i,max,r,g,b,co1,co2
Dim left,right,top,bottom

left = 0 : right = 0 : top = 0 : bottom = 0

rdiff = RVerlFarbe - RRahmFarbe : rdd = rdiff/2
gdiff = GVerlFarbe - GRahmFarbe : gdd = gdiff/2
bdiff = BVerlFarbe - BRahmFarbe : bdd = bdiff/2

lp = POlinks + STlinks -1 : tp = POoben + SToben-1
rp = FF_GetImageWidth() - POrechts - STrechts
bp = FF_GetImageHeight()- POoben - SToben

if STlinks > STrechts then max = STlinks else max = STrechts
if SToben > max then max = SToben
if STunten > max then max = STunten

for n = 0 to max - 1
	r = round(RRahmFarbe + rdd - rdiff * n / max) :	LIMIT r
	g = round(GRahmFarbe + gdd - gdiff * n / max) :	LIMIT g	
	b = round(BRahmFarbe + bdd - bdiff * n / max) :	LIMIT b
	co1 = b * (2^16) + g * (2^8) + r
	
	r = round(RRahmFarbe - rdd + rdiff * n / max) :	LIMIT r
	g = round(GRahmFarbe - gdd + gdiff * n / max) :	LIMIT g	
	b = round(BRahmFarbe - bdd + bdiff * n / max) :	LIMIT b
	co2 = b * (2^16) + g * (2^8) + r	

	left = (left + STlinks) / max
	right = (right + STrechts) / max
	top = (top + SToben) / max
	bottom = (bottom + STunten) / max

	if left >=1 then
		call FF_VLine(tp,bp,lp,co1)
		lp = lp - 1 : left = left -1
	end if

	if right >= 1 then
		call FF_VLine(tp,bp,rp,co2)
		rp = rp +1 : right = right -1
	end if
	
	if top >= 1 then
		call FF_HLine(lp+1,rp,tp,co1)
		tp = tp -1 : top = top -1
	end if
	
	if bottom >= 1 then
		call FF_HLine(lp+1,rp,bp,co2)
		bp = bp +1 : bottom = bottom - 1
	end if
next

End Function
'------------------------------------------------------------------------
Function BevelCut			'Schrgschnitt
Dim r,g,b,co1,co2,co3,co4
Dim lp,tp,rp,bp
Dim n,i,max
Dim left,right,top,bottom

left = 0 : right = 0 : top = 0 : bottom = 0

r = RRahmFarbe
g = GRahmFarbe
b = BRahmFarbe
co1 = b * (2^16) + g * (2^8) + r

r = round(RRahmFarbe - (128 - RegEffekt)/2) : LIMIT r
g = round(GRahmFarbe - (128 - RegEffekt)/2) : LIMIT g
b = round(BRahmFarbe - (128 - RegEffekt)/2) : LIMIT b
co2 = b * (2^16) + g * (2^8) + r

r = round(RRahmFarbe - (128 - RegEffekt)) : LIMIT r
g = round(GRahmFarbe - (128 - RegEffekt)) : LIMIT g
b = round(BRahmFarbe - (128 - RegEffekt)) : LIMIT b
co3 = b * (2^16) + g * (2^8) + r

r = round(RRahmFarbe - (128 - RegEffekt)*2) : LIMIT r
g = round(GRahmFarbe - (128 - RegEffekt)*2) : LIMIT g
b = round(BRahmFarbe - (128 - RegEffekt)*2) : LIMIT b
co4 = b * (2^16) + g * (2^8) + r

left = 0 : right = 0 : top = 0 : bottom = 0

lp = POlinks + STlinks -1 : tp = POoben + SToben-1
rp = FF_GetImageWidth() - POrechts - STrechts
bp = FF_GetImageHeight()- POoben - SToben

if STlinks > STrechts then max = STlinks else max = STrechts
if SToben > max then max = SToben
if STunten > max then max = STunten

for n = 0 to max - 1
	left = (left + STlinks) / max
	right = (right + STrechts) / max
	top = (top + SToben) / max
	bottom = (bottom + STunten) / max

	if left >=1 then
		call FF_VLine(tp,bp,lp,co3)
		lp = lp - 1 : left = left -1
	end if

	if right >= 1 then
		call FF_VLine(tp,bp,rp,co2)
		rp = rp +1 : right = right -1
	end if
	
	if top >= 1 then
		call FF_HLine(lp+1,rp,tp,co4)
		tp = tp -1 : top = top -1
	end if
	
	if bottom >= 1 then
		call FF_HLine(lp+1,rp,bp,co1)
		bp = bp +1 : bottom = bottom - 1
	end if
next

End Function
'------------------------------------------------------------------------
Function DrawText				'Text einblenden
Dim r,g,b,w,h,text,co1,ori,wei

if TextFont = "" then exit Function

w = FF_GetImageWidth() : h = FF_GetImageHeight()
r = RRahmFarbe
g = GRahmFarbe
b = BRahmFarbe
co1 = b * (2^16) + g * (2^8) + r
text = split(TextFont,"|")

call FF_SetArea(0,0,0,0,false,0,RegWeich * 64 / 255)
call FF_AreaFillRect(0,0,w,h,RegDeck)

ori = SToben
	do while ori < 0
		ori = ori + 3600
	loop
	do while ori > 3600
		ori = ori - 3600
	loop
wei = STrechts
	if wei < 0 then wei = 0
	if wei > 1000 then wei = 1000

call FF_TextAlign(30)
call FF_DrawText(text(0),POlinks,POoben,STlinks,ori,wei,SToben,false,text(1),co1)

End Function
'------------------------------------------------------------------------
Sub OrdnerAnlage(OrdnerPfad)
Dim array, Ordner, n

array = split(OrdnerPfad,"\")
Ordner = array(0) & "\"

For n = 1 to ubound(array)
	Ordner = objFS.BuildPath(Ordner,array(n))
 	if not objFS.FolderExists(Ordner) then
 		objFS.CreateFolder Ordner
 	end if
next

End Sub
'------------------------------------------------------------------------
Sub Zeilenanzahl
'in der Rahmendatei die Zeilen zhlen und prfen, ob mindestens eine Zeile mi ## beginnt
Dim RahmenZeile, tmpString

RDateiOK = false : RahmenzahlGesamt = 0
Set RahmenZeile = objFS.OpenTextFile(RahmenDatei, ForReading)

Do
	tmpString = RahmenZeile.ReadLine
	Zeilenzahl = Zeilenzahl + 1
	if instr(tmpString,"#") = 1 then
		RahmenzahlGesamt = RahmenzahlGesamt + 1
		RDateiOK = true
	end if
loop Until RahmenZeile.AtEndOfStream

RahmenZeile.Close

End Sub
'------------------------------------------------------------------------
Sub RahmenAuslesen
'Rahmendatei wird Zeile fr Zeile ausgelesen und verarbeitet
Dim RahmenZeile, tmpString, Datei, DateiTmp, Anzahl,Rahmennamen
Rahmenzahl = 0

'nur zum testen
if Testlauf then
	Rahmenart = Test
	call WertErmittlung
	call Aufruf_Rahmenart
	FF_Reload()
	exit sub
end if

Set RahmenZeile = objFS.OpenTextFile(RahmenDatei, ForReading)

Do

if FF_CheckKey() = 8 then Abbruch = true	'8 = Backspace

	tmpString = RahmenZeile.ReadLine
	if tmpString = "" then exit do
	if instr(tmpString,"#") = 1 then

		if Abbruch then
			Abbruch = false
			Antwort = msgbox("Von insgeamt " & RahmenzahlGesamt & " wurden bisher " & Rahmenzahl & " Muster erzeugt." & vbNewLine & _
							 "Soll die Mustererzeugung jetzt abgebrochen werden?",vbYesNo + vbQuestion,"Abfrage")
			if Antwort = vbYes then 
				Abbruch = true
				exit do
			end if
		end if
		
		tmpString = mid(tmpString,2)
		Rahmennamen = tmpString
		do
			Abbruch = false
			call Dateinamentest (tmpString)
			if Abbruch then
				msg = "Der Dateiname '" & tmpString & "' enthlt das" & vbNewline & _
			   		  "unzulssige Zeichen '" & Element & "'." & vbNewline & vbNewline & _
			   		  "Korrigieren Sie den Dateinamen!" & vbNewline & _
			   		  "(Mit 'Abbrechen' wird das Skript vorzeitig beendet.)"
				DateiTmp = InputBox(msg,"Dateinamensyntax",tmpString)
				if len(DateiTmp) > 0 then 
					tmpString = DateiTmp 
				else
					msgbox "Das Skript wird abgebrochen!",vbInformation,"Hinweis"
					exit Sub
				end if
			else
				exit do
			end if
		loop
		
		if len(Datei) > 0 then
			call MusterAblage (Datei)
			FF_PopImage()
			FF_PushImage()
		end if
		Datei = MusterDatei & tmpString & ".jpg"
	else
		RahmenArt = tmpString
		call WertErmittlung
		call Aufruf_Rahmenart
	end if
	
	Anzahl = Anzahl + 1
	FF_SetProgressText Anzahl,Zeilenzahl,Rahmenzahl & " - " & Rahmennamen
	
loop Until RahmenZeile.AtEndOfStream

'Musterrahmen speichern
call MusterAblage (Datei)
FF_SetProgressText Anzahl,Zeilenzahl,Rahmenzahl & " - " & Rahmennamen

if Anzeige then FF_Reload()	'nur zum testen

RahmenZeile.Close

End Sub
'------------------------------------------------------------------------
Sub MusterAblage (byval Datei)
'### Muster ggf. ausschneiden, ggf. verkleinern und dann abspeichern

if instr(Datei,"[lio]") > 0 then
	'Musterrahmen ausschneiden (Viertel links oben)
	call FF_Crop(0,0,FF_GetImageWidth()/2,FF_GetImageHeight()/2)
elseif instr(Datei,"[reu]") > 0 then
	'Musterrahmen ausschneiden (Viertel rechts unten)
	call FF_Crop(FF_GetImageWidth()/2,FF_GetImageHeight()/2,FF_GetImageWidth()/2,FF_GetImageHeight()/2)
end if			

'Musterrahmen verkleinern
if not Turbo and boolVerkleinern = "1" and _	
	(FF_GetImageWidth() > MaxLaenge or FF_GetImageHeight() > MaxLaenge) then
	call FF_HQScale(MaxLaenge,MaxLaenge, true)
end if

'Musterrahmen speichern
call FF_SaveImage(Datei,quality) 	'Name,Qualitt -> 0 = FF-Einstellung
Rahmenzahl = Rahmenzahl + 1

End Sub
'------------------------------------------------------------------------

Sub KurzbeschreibungAnzeigen

Dim Taste
Dim FBreite	: FBreite = LaengeMax * 2.6 + 15
const FHoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",FBreite,FHoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,FBreite,FHoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",FBreite/2-15,FHoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\FF_MFDL_Muster
const Qualitaeten = "0/65/70/75/80/85/90/95/100"
Dim ArrayQuality

'Werte auslesen
RahmenDatei = FF_GetProfile ("FF_MFDL_Muster","RahmenDatei")	'Datei mit Rahmentexte
MusterDatei = FF_GetProfile ("FF_MFDL_Muster","MusterDatei")	'Musterordner - wird jeweils ergnzt um Musternamen
quality = FF_GetProfile ("FF_MFDL_Muster","quality")			'JPEG-Qualitt
boolVerkleinern = FF_GetProfile ("FF_MFDL_Muster","boolV")		'bei "1" verkleinern
MaxLaenge = FF_GetProfile ("FF_MFDL_Muster","MaxLaenge")		'max. Lnge fr Verkleinerung

'### Werte eintragen

if RahmenDatei = "" then RahmenDatei = FF_GetScriptPath() & "\MFDL.cfg"				'Standard-Rahmnedatei
FF_SetControl "MFDL-Muster","Rahmentext",RahmenDatei
if Musterdatei = "" then Musterdatei = FF_GetScriptPath() & "\MFDL-Muster\MFDL\"	'entspricht Musterdatei fr MFDL-Manager
FF_SetControl "MFDL-Muster","Muster",MusterDatei

'JPEG-Qualitt
ArrayQuality = split(Qualitaeten,"/")
For each Element in ArrayQuality
	FF_SetControl "MFDL-Muster","JPEGquality",Element
next
if quality = "" then quality = 75
FF_SetControl "MFDL-Muster","JPEGquality",quality

'Verkleinern
if boolVerkleinern = "" then boolVerkleinern = "1"
FF_SetControl "MFDL-Muster","boolVerkleinern",boolVerkleinern
if MaxLaenge = "" then MaxLaenge = 500
FF_SetControl "MFDL-Muster","MaxLaenge",MaxLaenge

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\FF_MFDL_Muster

'Rahmendatei und Musterordner
RahmenDatei = FF_GetControl("MFDL-Muster","Rahmentext")
MusterDatei = FF_GetControl("MFDL-Muster","Muster")
FF_WriteProfile "FF_MFDL_Muster","RahmenDatei",RahmenDatei
FF_WriteProfile "FF_MFDL_Muster","MusterDatei",MusterDatei

'JPEG-Qualitt
quality = FF_GetControl("MFDL-Muster","JPEGquality")
FF_WriteProfile "FF_MFDL_Muster","quality",quality

'Verkleinern
boolVerkleinern = FF_GetControl("MFDL-Muster","boolVerkleinern")
FF_WriteProfile "FF_MFDL_Muster","boolV",boolVerkleinern
MaxLaenge = FF_GetControl("MFDL-Muster","MaxLaenge") * 1
FF_WriteProfile "FF_MFDL_Muster","MaxLaenge",MaxLaenge

End Sub
'------------------------------------------------------------------------
Sub Dateinamentest (Dateiname)
Dim Zeichen
Abbruch = false

Zeichen = split(VerbZ,",")
for each Element in Zeichen
	if instr(Dateiname,Element) > 0 then
		Abbruch = true
		exit sub
	end if
next

if instr(Dateiname,"""") > 0 then
	Element = """"
	Abbruch = true
end if

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad
const RegSchluessel = "\FF_MFDL_Muster\"

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
'TempFile = FF_GetScriptPath & "\Beipack.txt"		'Dateibeispiel
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'TempFile = FF_GetScriptPath & "\BeipackSammlung"	'Ordnerbeispiel
'if objFS. FolderExists (TempFile) then objFS. DeleteFolder TempFile,true

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script" & RegSchluessel
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Nach Durchfhrung der 'Automatischen Skriptkonfiguration' ist das Skript" & vbNewLine & _
		Skriptname & " mit allen Komponenten gelscht!",vbExclamation,"Hinweis"
End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------